using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace BMA.EHR.Infrastructure.Migrations.DisciplineDb
{
    /// <inheritdoc />
    public partial class updatetableDisciplineDisciplinarysaddDisciplineDisciplinary_DocRelevant : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.AddColumn<string>(
                name: "DisciplinaryCauseText",
                table: "DisciplineDisciplinarys",
                type: "longtext",
                nullable: true,
                comment: "ผลการสอบสวน กรณีมีมูล")
                .Annotation("MySql:CharSet", "utf8mb4");

            migrationBuilder.AddColumn<string>(
                name: "DisciplinaryResult",
                table: "DisciplineDisciplinarys",
                type: "longtext",
                nullable: true,
                comment: "ผลการสอบสวน เหตุผล")
                .Annotation("MySql:CharSet", "utf8mb4");

            migrationBuilder.AddColumn<string>(
                name: "DisciplinaryStatusResult",
                table: "DisciplineDisciplinarys",
                type: "longtext",
                nullable: true,
                comment: "ผลการสอบสวน ผล")
                .Annotation("MySql:CharSet", "utf8mb4");

            migrationBuilder.CreateTable(
                name: "DisciplineDisciplinary_DocRelevants",
                columns: table => new
                {
                    Id = table.Column<Guid>(type: "char(36)", nullable: false, comment: "PrimaryKey", collation: "ascii_general_ci"),
                    CreatedAt = table.Column<DateTime>(type: "datetime(6)", nullable: false, comment: "สร้างข้อมูลเมื่อ"),
                    CreatedUserId = table.Column<string>(type: "varchar(40)", maxLength: 40, nullable: false, comment: "User Id ที่สร้างข้อมูล")
                        .Annotation("MySql:CharSet", "utf8mb4"),
                    LastUpdatedAt = table.Column<DateTime>(type: "datetime(6)", nullable: true, comment: "แก้ไขข้อมูลล่าสุดเมื่อ"),
                    LastUpdateUserId = table.Column<string>(type: "varchar(40)", maxLength: 40, nullable: false, comment: "User Id ที่แก้ไขข้อมูลล่าสุด")
                        .Annotation("MySql:CharSet", "utf8mb4"),
                    CreatedFullName = table.Column<string>(type: "varchar(200)", maxLength: 200, nullable: false, comment: "ชื่อ User ที่สร้างข้อมูล")
                        .Annotation("MySql:CharSet", "utf8mb4"),
                    LastUpdateFullName = table.Column<string>(type: "varchar(200)", maxLength: 200, nullable: false, comment: "ชื่อ User ที่แก้ไขข้อมูลล่าสุด")
                        .Annotation("MySql:CharSet", "utf8mb4"),
                    DocumentId = table.Column<Guid>(type: "char(36)", nullable: false, collation: "ascii_general_ci"),
                    DisciplineDisciplinaryId = table.Column<Guid>(type: "char(36)", nullable: false, collation: "ascii_general_ci")
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_DisciplineDisciplinary_DocRelevants", x => x.Id);
                    table.ForeignKey(
                        name: "FK_DisciplineDisciplinary_DocRelevants_DisciplineDisciplinarys_~",
                        column: x => x.DisciplineDisciplinaryId,
                        principalTable: "DisciplineDisciplinarys",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_DisciplineDisciplinary_DocRelevants_Documents_DocumentId",
                        column: x => x.DocumentId,
                        principalTable: "Documents",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                })
                .Annotation("MySql:CharSet", "utf8mb4");

            migrationBuilder.CreateIndex(
                name: "IX_DisciplineDisciplinary_DocRelevants_DisciplineDisciplinaryId",
                table: "DisciplineDisciplinary_DocRelevants",
                column: "DisciplineDisciplinaryId");

            migrationBuilder.CreateIndex(
                name: "IX_DisciplineDisciplinary_DocRelevants_DocumentId",
                table: "DisciplineDisciplinary_DocRelevants",
                column: "DocumentId");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "DisciplineDisciplinary_DocRelevants");

            migrationBuilder.DropColumn(
                name: "DisciplinaryCauseText",
                table: "DisciplineDisciplinarys");

            migrationBuilder.DropColumn(
                name: "DisciplinaryResult",
                table: "DisciplineDisciplinarys");

            migrationBuilder.DropColumn(
                name: "DisciplinaryStatusResult",
                table: "DisciplineDisciplinarys");
        }
    }
}
